<?php

declare(strict_types=1);

namespace App\Service;

use App\Repository\TblModuloXUsuarioRepository;

final class TblModuloXUsuarioService
{
    private TblModuloXUsuarioRepository $TblModuloXUsuarioRepository;

    public function __construct(TblModuloXUsuarioRepository $TblModuloXUsuarioRepository)
    {
        $this->TblModuloXUsuarioRepository = $TblModuloXUsuarioRepository;
    }

    public function checkAndGet(int $TblModuloXUsuarioId): object
    {
        return $this->TblModuloXUsuarioRepository->checkAndGet($TblModuloXUsuarioId);
    }

    public function getAll(): array
    {
        return $this->TblModuloXUsuarioRepository->getAll();
    }

    public function getOne(int $TblModuloXUsuarioId): object
    {
        return $this->checkAndGet($TblModuloXUsuarioId);
    }

    public function create(array $input): object
    {
        $TblModuloXUsuario = json_decode((string) json_encode($input), false);

        return $this->TblModuloXUsuarioRepository->create($TblModuloXUsuario);
    }

    public function update(array $input, int $TblModuloXUsuarioId): object
    {
        $TblModuloXUsuario = $this->checkAndGet($TblModuloXUsuarioId);
        $data = json_decode((string) json_encode($input), false);

        return $this->TblModuloXUsuarioRepository->update($TblModuloXUsuario, $data);
    }

    public function delete(int $TblModuloXUsuarioId): void
    {
        $this->checkAndGet($TblModuloXUsuarioId);
        $this->TblModuloXUsuarioRepository->delete($TblModuloXUsuarioId);
    }
}
